datablock AudioProfile(MolotovCocktailsmashSound)
{
   filename    = "./breakglass.wav";
   description = AudioDefault3d;
   preload = false;
};
datablock AudioProfile(lighterSound)
{
   filename    = "./lighter.wav";
   description = AudioDefault3d;
   preload = false;
};
datablock ParticleData(clothburn)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.0;
	gravityCoefficient   = -0.7;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";

	sizes[0]	= 0.0;
	sizes[1]	= 0.2;
	sizes[2]	= 0.01;

	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(clothburnemitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.10;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   //lifetimeMS = 5000;
   particles = clothburn;   


};




//----------------------------------------------------------------------------------------------


  // uiName = "Molotov Fire";//exec("add-ons/weapon_molotovCocktail/weapon_molotovCocktail.cs");

datablock DebrisData(fireDebris)
{
   emitters = "vehicleburnEmitter";

	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 10.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.1;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	
   radiusDamage        = 10;
   damageRadius        = 4;

	gravModifier = 2;
};



datablock ExplosionData(FireExplosion)
{
   soundProfile   = MolotovCocktailsmashsound;
   lifeTimeMS = 10000;

   emitter[0] = vehicleburnEmitter;
   //emitter[1] = Fires2Emitter;
   

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
	playerBurnTime = 5000;
 
   
      debris = fireDebris;
   debrisNum = 8;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 30;
   debrisThetaMax = 30;
   debrisVelocity = 10;
   debrisVelocityVariance = 1;
};



AddDamageType("Molotovfire",   '<bitmap:add-ons/Weapon_MolotovCocktail/ci_fire> %1',    '%2 <bitmap:add-ons/weapon_MolotovCocktail/ci_fire> %1',1,1);

datablock ProjectileData(MolotovCocktailProjectile)
{
   projectileShapeName = "./MolotovCocktailp2.dts";
   directDamage        = 10;
   radiusDamage        = 10;
   damageRadius        = 7;
   directDamageType  = $DamageType::Molotovfire;
   radiusDamageType  = $DamageType::Molotovfire;
   impactImpulse	   = 200;
      particleemitter           = clothburnemitter;
   verticalImpulse	   = 200;
   explosion           = fireExplosion;
   //particleEmitter     = MolotovCocktailTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 30;
   velInheritFactor    = 0;
   explodeOnDeath = true;

   armingDelay         = 0; 
   lifetime            = 2500;
   fadeDelay           = 3000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

  // uiName = "Molotov Cocktail";
};




//////////
// item //
//////////
datablock ItemData(MolotovCocktailItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MolotovCocktail2.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Molotov Cocktail";
	iconName = "./MolotovCocktail";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = MolotovCocktailImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MolotovCocktailImage)
{
   // Basic Item properties
   shapeFile = "./MolotovCocktail2.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MolotovCocktailItem;
   ammo = " ";
   projectile = MolotovCocktailProjectile;
   projectileType = Projectile;



   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "light";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "light";
	stateTransitionOnTimeout[2]	= "Fireed";
		stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]	= false;
	stateTimeoutValue[2]		= 1.0;
	stateSound[2]				= lighterSound;

	stateEjectShell[2]       = true;

	stateName[3]			= "Fireed";
	stateEmitter[3]			   = clothburnEmitter;
	stateEmitterTime[3]		   = 100000;
		stateEmitterNode[3]				= "emitterNode";
	stateTransitionOnTriggerDown[3]	= "Charge";
	stateAllowImageChange[3]	= false;
	
	stateName[4]                    = "Charge";
		stateEmitter[4]			   = clothburnEmitter;
	stateEmitterTime[4]		   = 100000;
			stateEmitterNode[4]				= "emitterNode";
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.7;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "AbortCharge";
	stateScript[4]                  = "onCharge";
	stateAllowImageChange[4]        = false;
	
	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "fireed";
		stateEmitter[5]			   = clothburnEmitter;
	stateEmitterTime[5]		   = 100000;
			stateEmitterNode[5]				= "emitterNode";
	stateTimeoutValue[5]		= 0.3;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Armed";
		stateEmitter[6]			   = clothburnEmitter;
	stateEmitterTime[6]		   = 100000;
			stateEmitterNode[6]				= "emitterNode";
	stateTransitionOnTriggerUp[6]	= "Fire";
	stateAllowImageChange[6]	= false;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Done";
	stateTimeoutValue[7]		= 0.5;
	stateFire[7]			= true;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Done";
	stateScript[8]					= "onDone";

};

package MolotovCocktailPackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "MolotovCocktailItem" && %col.canPickup)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(MolotovCocktailPackage);

function MolotovCocktailImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastHESlot = %obj.currTool;
}

function MolotovCocktailImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}



function MolotovCocktailImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::OnFire(%this, %obj, %slot);

	%currSlot = %obj.lastHESlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function MolotovCocktailImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

function MolotovCocktailProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   %player = %obj;
   %client = %obj.client;
 if(isObject(%player.client.minigame))
{

   continuousDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,%this.radiusDamageType,0,10000);
}
return;
parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}
      // %this.minigame.messageAll('',%msg);


function continuousDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse,%duration)
{


		radiusDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse);
		if (%duration<0) return;
		schedule(200,0,continuousDamage,%sourceObject, %position, %radius, %damage, %damagetype, %impulse,%duration-500);

}
function MolotovCocktailProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   %player = %obj;
   %client = %obj.client;

return;
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
	   if(isObject(%player.client.minigame))
	{

		continuousDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,%this.radiusDamageType,0,10000);
	}
	  
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
	   if(isObject(%player.client.minigame))
{

   continuousDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,%this.radiusDamageType,0,10000);
}
   }	
}
